import 'package:b2b_graphql_package/GraphQLConfiguration.dart';
import 'package:b2b_graphql_package/modules/account/user_repo.dart';

import 'package:flutter/material.dart';
import 'package:graphql_flutter/graphql_flutter.dart';

import 'modules/auth/auth_repo.dart';
import 'modules/cart/cart_repo.dart';
import 'modules/local_cart/local_cart.repo.dart';
import 'modules/order/order_repo.dart';

void main() async {
  GraphQLConfiguration graphQLConfiguration = await setupGraphQl();
  runApp(MyApp(graphQLConfiguration.client));
}

Future<GraphQLConfiguration> setupGraphQl() async {
  const serviceUri =
      'https://o6uj5ktn85.execute-api.ap-south-1.amazonaws.com/qa/';
  GraphQLConfiguration graphQLConfiguration =
      GraphQLConfiguration.config(serviceUri);
  await graphQLConfiguration.initiateGraphQl();
  return graphQLConfiguration;
}

class MyApp extends StatelessWidget {
  ValueNotifier<GraphQLClient>? _graphQlClient;
  MyApp(ValueNotifier<GraphQLClient> valueNotifierclient) {
    _graphQlClient = valueNotifierclient;
  }
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return GraphQLProvider(
      client: _graphQlClient,
      child: MaterialApp(
        title: 'Flutter Demo',
        theme: ThemeData(
          primarySwatch: Colors.blue,
        ),
        home: MyHomePage(title: 'Flutter Demo Home Page'),
      ),
    );
  }
}

class MyHomePage extends StatefulWidget {
  MyHomePage({Key? key, required this.title}) : super(key: key);

  final String title;

  @override
  _MyHomePageState createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  int _counter = 0;

  void _incrementCounter() {
    // setState(() {
    //   _counter++;
    // });
    getSettings();
  }

  Future getSettings() async {
    OrderRepo mm = new OrderRepo();
    var result = await mm.getOrderList('6133ba5c8ebd38000a38d825', 1, 15);
    // var result = await mm.getServerCartCount('6133ba5c8ebd38000a38d825');
    print(result);
    // var request = [
    //   {
    //     "packId": "613ccf61c10e0a0009a74c21",
    //     "setId": "613ccf60c10e0a0009a74bfd",
    //     "quantity": 2
    //   }
    // ];
    // LocalCartRepo lc = new LocalCartRepo();
    // var result = await lc.getLocalCart(request);
    // print(result);
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        // Here we take the value from the MyHomePage object that was created by
        // the App.build method, and use it to set our appbar title.
        title: Text(widget.title),
      ),
      body: Center(
        // Center is a layout widget. It takes a single child and positions it
        // in the middle of the parent.
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            Text(
              'You have pushed the button this many times:',
            ),
            Text(
              '$_counter',
              style: Theme.of(context).textTheme.headline4,
            ),
          ],
        ),
      ),
      floatingActionButton: FloatingActionButton(
        onPressed: _incrementCounter,
        tooltip: 'Increment',
        child: Icon(Icons.add),
      ), // This trailing comma makes auto-formatting nicer for build methods.
    );
  }
}
