import 'package:graphql_flutter/graphql_flutter.dart';

import '../../GraphQLConfiguration.dart';
import 'cart_model.dart';

class CartRepo {
  var graphQLConfiguration;

  var serverCartCount;
  CartRepo() {
    graphQLConfiguration = GraphQLConfiguration();
  }

  Future getServerCartCount(String userId) async {
    GraphQLClient _client = graphQLConfiguration.clientToQuery();

    var cartCountGql = """ 
              query serverCartCount(\$userId: String) {
              serverCartCount(userId: \$userId)
            }
            """;

    final vble = {
      "id": userId,
    };
    QueryResult result = await _client.query(QueryOptions(
      document: gql(cartCountGql),
      variables: vble,
      fetchPolicy: FetchPolicy.networkOnly,
    ));

    if (!result.hasException) {
      var serverCartCountModel = result.data!["serverCartCount"];

      if (serverCartCountModel != null) {
        serverCartCount = cartCountFromJson(serverCartCountModel);
        return serverCartCount;
      }
    }
    return serverCartCount;
  }
}
